<?php
/**
 * This files contains examples of how to use the JimsAPI
 */
$loader = require __DIR__ . '/vendor/autoload.php';


// Include the JimsAPI
use JimsGroup\Api;
use JimsGroup\Utilities\Logger;


// Create an instance of the JimsAPI
$jimsAPI = new Api();

// Get the CustomerBooking API
$customerBookingApi = $jimsAPI->getCustomerBookingApi();
$customerBookingApi->setMode('hf');

//$info = $jimsAPI->getFMSInfoApi();
//
//Logger::simpleLog($info->getDivisions('json'), 'divisions.json');

// Get the initial booking request
$initialBookingRequest = $customerBookingApi->getInitialBookingRequest([
    'countryCode' => 'AU',
]);

//exit();

$customerBookingApi->setAuthToken('3e8bce9e-be45-4499-b31a-23b6fb067aa7');

//exit();

$address = new \JimsGroup\Datatypes\AddressType([
    "full_address" => "125 Heyders Road, Spencerville, Christchurch, New Zealand",
    "geocode_y" => -43.4322503,
    "geocode_x" => 172.695362,
    "street_number" => "125",
    "street_name" => "Heyders Road",
    "suburb" => "Spencerville",
    "state" => "Canterbury",
    "country" => "NZ",
    "postcode" => "8083",
    "unit_number" => ""
]);

//Log results
//Logger::simpleLog($division_services, 'example-mowing.log');
$allocationRequestResponse = null; $finalizeBookingResponse = null;
$allocationRequestResponseObj = $customerBookingApi->sendAllocationRequest (
    5,
    [766],
    $address->toArray (),
    [
        'address' => null,
        'addressString' => $address->getFullAddress (),
        'allow_rating' => true,
        'comments' => 'cb3 brandsource and confirmed not previous client',
        'isUserInfoConfirmed' => null,
        'emailAddress' => 'flint.janos2@hello.com',
        'firstName' => 'Flint',
        'lastName' => 'Jackal',
        'phoneNumber' => '472888997',
        'subscribed' => true,
        'businessName' => null
    ],
    $customerBookingApi->getAuthToken(),
);

error_log ( json_encode( $allocationRequestResponseObj->toArray () ) );

error_log ( json_encode( [$allocationRequestResponseObj->hasPayload ()] ) );

if($allocationRequestResponseObj->hasPayload ()) {

//    error_log ( json_encode( $allocationRequestResponseObj->getPayload () ) );

    $allocationRequestResponse = new \JimsGroup\Datatypes\AllocationResponsePayloadType($allocationRequestResponseObj->getPayload (), true);

//    error_log( json_encode( $allocationRequestResponse->toArray () ) );
//
//    error_log( json_encode( $allocationRequestResponseObj->getPreviousLeadId() ) );
//
//    exit();

    //check if $allocationRequestResponse has bookingConfirmMsg property set and its populated
    if($allocationRequestResponseObj->isBookingCompleted ()) {
        exit($allocationRequestResponseObj->getStatusMessage ());
    }

    $bookedProvider = $allocationRequestResponse->getBookedProvider();

    if(empty($bookedProvider)) {
        exit($allocationRequestResponse->getStatusMessage ());
    }

    //check if $allocationRequestResponse has avaliableFSEs property set, its array and its not empty
    if( !empty($bookedProvider) && is_array($bookedProvider) && !empty($bookedProvider)) {

        $params = [
        'booking_request_id' => $allocationRequestResponseObj->getPayload ()['bookingRequestId'],
            'division_id' => 5,
            'service_ids' => [344,1750],
            'choosedProviderId' => $bookedProvider['business_id'],
            'user_ip_address' => '127.0.0.1',
            'provider_info' => $bookedProvider,
            'user_info' => [
                'address' => null,
//                'addressString' => '326 Canterbury Rd, Forest Hill VIC 3131, Australia',
                'addressString' => $address->getFullAddress (),
                'allow_rating' => true,
                'comments' => 'cb3 brandsource and confirmed not previous client',
                'isUserInfoConfirmed' => null,
                'emailAddress' => 'flint.janos2@hello.com',
                'firstName' => 'Flint',
                'lastName' => 'Jackal',
                'phoneNumber' => '472888997',
                'subscribed' => true,
                'businessName' => null
            ],
            'bookingConfirmCode' => $allocationRequestResponseObj->getPayloadProperty ('bookingConfirmCode'),
            'previous_lead_id' => $allocationRequestResponseObj->getPreviousLeadId(),
        ];

//        exit();

        /**
         * @var $customerBookingApi \JimsGroup\Apis\CustomerBooking
         * @var $finalizeBookingResponse \JimsGroup\Datatypes\BookingResponseType
         */
        $finalizeBookingResponse = $customerBookingApi->sendFinalizeBookingRequest(
            ...$params
        );

        error_log ( json_encode( $finalizeBookingResponse->toArray () ) );
    }

}

echo json_encode ([
    'allocationRequestResponse' => $allocationRequestResponse,
    'finalizeBookingResponse' => $finalizeBookingResponse->getStatusMessage ()
]);
